#ifndef	VGAPAINT_BRUSH_H
#define	VGAPAINT_BRUSH_H

#include "vgapaint.h"
#include <math.h>

#ifdef	VGAPAINT_BRUSH_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

#define	M_PI	3.141592653589793238462643

#define	PasteBrush(b,x,y)	sprite_paste(b,&brush_sprite,x,y)

EXTERN	struct	Picture	brush_picture;		// AnimBrush
EXTERN	struct	Picture	brush_old_picture;	// AnimBrush
EXTERN	struct	BitMap	brush_bm;
EXTERN	struct	Sprite	brush_sprite;		// brush's sprite
EXTERN	struct	BitMap	brush_oldbm;		// brush's old bitmap (translate)
EXTERN	uchar *	brushsave	INIT(NULL);	// brush save memory
EXTERN	coord	brush_hx	INIT(0);	// brush x handle
EXTERN	coord	brush_hy	INIT(0);	// brush y handle
EXTERN	coord	brush_hpos	INIT(4);	// brush handle position
EXTERN	coord	brush_ox	INIT(0);	// brush x pickup offset
EXTERN	coord	brush_oy	INIT(0);	// brush y pickup offset
EXTERN	boolean	brush		INIT(FALSE);	// have brush
EXTERN	boolean	brush_picture_alloc	INIT(FALSE);
EXTERN	void	(*br_plotback)(struct BitMap *,coord,coord,color);

EXTERN	uchar dotsave[1];

extern	uchar dot[];


void	OffBrush(void);
void	OnBrush(void);
void	PasteBrush2(BMP bm,coord x,coord y,color color);
boolean	AllocBrush(coord x,coord y);
void	FreeBrush(void);
void	GetBrush(coord x1,coord y1,coord x2,coord y2);
void	GetStdBrush(int id);
void	BrushMode(int md);

void	brush_flipx(void);
void	brush_flipy(void);
void	brush_rotright(void);
void	brush_handle_readjust(void);
void	brush_handle_cycle(void);
void	brush_handle_center(void);
void	brush_scale(void);
void	brush_double(void);
void	brush_halve(void);
void	brush_double_x(void);
void	brush_double_y(void);
void	brush_free_rotate(void);

void	brush_translate(long width,long height,void (*func)(BMP dst,BMP src,void *),void *data);
void	brush_remap(void);

void	BrushNextFrame(void);
void	BrushPrevFrame(void);
void	BrushInsertFrameBefore(void);
void	BrushInsertFrameAfter(void);
void	BrushDeleteCurrentFrame(void);

double	Angle(long,long,long,long);

#undef	EXTERN
#undef	INIT

#endif

