#include <a/types.h>
#include "vgapaint.h"
#include "videos.h"

#define FFFRAME_SIZE	1024

struct FFFrame {
	ulong x,xl,xr,y;
	uchar *memptr;
};

void flood(void);
static boolean addhead(coord x1,coord y1,uchar *vptr);
static boolean remtail(coord *x,coord *y,uchar **vptr);

struct FFFrame *FFFrame,*FF1,*FF2;
int _ff_color,_ff_ovcolor;
int _ffsize,FF1Index,FF2Index;
int ffwinx1,ffwiny1,ffwinx2,ffwiny2,ffbpr;

TOOLDEFINE(doFloodFill) {
	uchar *vm;
	if (!(FFFrame=(struct FFFrame *)malloc(sizeof(struct FFFrame [FFFRAME_SIZE])))) return;
	ffwinx1	= winbm->x1;
	ffwiny1	= winbm->y1;
	ffwinx2	= winbm->x2-1;
	ffwiny2	= winbm->y2-1;
	ffbpr	= winbm->bpr;

	_ff_color=colr;
	_ffsize=FF1Index=FF2Index=0;
	FF1=FF2=FFFrame;

	if (x1<ffwinx1 || x1>ffwinx2 || y1<ffwiny1 || y1>ffwiny2) return;
	vm=winbm->vm+ffbpr*y1+x1;
	_ff_ovcolor=*vm;

	if (_ff_ovcolor == _ff_color) return;

	if (addhead(x1,y1,vm)) return;
	mouse_hide();
	flood();
	mouse_show();
	free(FFFrame);
}

void flood(void) {
	mouse_coord x,y,x1,x2;
	uchar *vptr,*vptrl,*vptrr;

	while (!remtail(&x,&y,&vptr)) {
		x1=x2=x;
		vptrl=vptrr=vptr;

		*vptr=_ff_color;

		/* scan left and find coordinate & addr of left boundary */

		while (--vptrl,--x1>=ffwinx1)
			if (*vptrl!=_ff_ovcolor) break;
			else *vptrl=_ff_color;

		/* scan right and find coordinate & addr of right boundary */

		while (++vptrr,++x2<=ffwinx2)
			if (*vptrr!=_ff_ovcolor) break;
			else *vptrr=_ff_color;

		vid_tap_rect2(winbm,x1+1,y,x2-1,y);

		/* x1/vptrl: left boundary */
		/* x2/vptrr: right boundary */

		if (y>ffwiny1) {
			vptr=vptrl+1-ffbpr;
			x=x1+1;
			while(x<x2) {
				if (*vptr == _ff_ovcolor) {
					addhead(x,y-1,vptr);
					while (x<x2)
						if (*vptr != _ff_ovcolor) break;
						else ++vptr,++x;
				};
				vptr++;
				x++;
			};
		};
		if (y<ffwiny2) {
			vptr=vptrl+1+ffbpr;
			x=x1+1;
			while(x<x2) {
				if (*vptr == _ff_ovcolor) {
					addhead(x,y+1,vptr);
					while (x<x2)
						if (*vptr != _ff_ovcolor) break;
						else ++vptr,++x;
				};
				vptr++;
				x++;
			};
		};
		if (-1 != kbd_check()) break;
	};
}
#if 0
void flood_func(void) {
	mouse_coord x,y,x1,x2;
	uchar *vptr,*vptrl,*vptrr;

	while (!remtail(&x,&y,&vptr)) {
		x1=x2=x;
		vptrl=vptrr=vptr;

		*vptr=_ff_color;

		/* scan left and find coordinate & addr of left boundary */

		while (--vptrl,--x1>=ffwinx1)
			if (*vptrl!=_ff_ovcolor) break;

		/* scan right and find coordinate & addr of right boundary */

		while (++vptrr,++x2<=ffwinx2)
			if (*vptrr!=_ff_ovcolor) break;

		// draw the line



		vid_tap_rect2(winbm,x1+1,y,x2-1,y);

		/* x1/vptrl: left boundary */
		/* x2/vptrr: right boundary */

		if (y>ffwiny1) {
			vptr=vptrl+1-ffbpr;
			x=x1+1;
			while(x<x2) {
				if (*vptr == _ff_ovcolor) {
					addhead(x,y-1,vptr);
					while (x<x2)
						if (*vptr != _ff_ovcolor) break;
						else ++vptr,++x;
				};
				vptr++;
				x++;
			};
		};
		if (y<ffwiny2) {
			vptr=vptrl+1+ffbpr;
			x=x1+1;
			while(x<x2) {
				if (*vptr == _ff_ovcolor) {
					addhead(x,y+1,vptr);
					while (x<x2)
						if (*vptr != _ff_ovcolor) break;
						else ++vptr,++x;
				};
				vptr++;
				x++;
			};
		};
		if (-1 != kbd_check()) break;
	};
}
#endif
static boolean addhead(coord x1,coord y1,uchar *ptr) {
	if (++_ffsize>FFFRAME_SIZE) {
		--_ffsize;
		return TRUE;
	};
	FF2->x=x1;
	FF2->y=y1;
	FF2->memptr=ptr;
	if (++FF2Index>=FFFRAME_SIZE) {
		FF2Index=0;
		FF2=FFFrame;
	} else FF2++;
	return FALSE;
}

static boolean remtail(coord *x1,coord *y1,uchar **ptr) {
	if (--_ffsize<0) {
		++_ffsize;
		return TRUE;
	};
	*x1=FF1->x;
	*y1=FF1->y;
	*ptr=FF1->memptr;
	if (++FF1Index>=FFFRAME_SIZE) {
		FF1Index=0;
		FF1=FFFrame;
	} else FF1++;
	return FALSE;
}
