#ifndef	VGAPAINT_FONT_H
#define VGAPAINT_FONT_H

#include <a/types.h>

#include "video.h"

typedef	short		fontKern;
typedef	short		fontWidth;
typedef	short		fontSize;
typedef	long		fontOffset;

enum FontRenderFlags {
	FRF_FGNORMAL	= 0x00000000L,
	FRF_FGXOR	= 0x00000001L,
	FRF_FGTRANS	= 0x00000002L,
	FRF_FGMODEMASK	= 0x0000000FL,
	FRF_BGNORMAL	= 0x00000000L,
	FRF_BGXOR	= 0x00000010L,
	FRF_BGTRANS	= 0x00000020L,
	FRF_BGMODEMASK	= 0x000000F0L,
	FRF_REVERSE	= 0x00000100L,
	FRF_BOLD	= 0x00000200L,
	FRF_ITALIC	= 0x00000400L,
	FRF_UNDERLINE	= 0x00000800L,
};

struct Font {
	ulong		width;			// max width of character
	ulong		height;			// max height of character
	ulong		baseline;		// baseline
	uchar		charlow;		// lowest character
	uchar		charhigh;		// highest character
	short		charmissing;		// index to use for missing character #
	short		chartotal;		// total # of characters
	uchar		pad0[2];
	fontKern	*kernTable;		// table: cell left to character left
	fontWidth	*widthTable;		// table: width of character within cell
	fontSize	*sizeTable;		// table: width of character cell
	fontOffset	*offsetTable;		// table: x column # into data
	uchar		*data;
	ulong		dataBpr;
};

struct Font *	LoadFont(char *fname);
void		FreeFont(struct Font *);

void	vid13_RenderFont(BMP bm,struct Font *font,coord x1,coord y1,uchar f,uchar b,ulong flags,char *text,ulong lim);
ulong	TextLength(struct Font *f,char *s);

#endif

