#include "list.h"

#define	NULL	0

void NewList(struct List *list) {
	list->next=(struct Node *)&list->prevnext;
	list->prevnext=NULL;
	list->prev=(struct Node *)&list->next;
}

void AddHead(struct List *list,struct Node *node) {
	node->prev=list->prev;
	node->next=(struct Node *)&list->prevnext;
	node->prev->next=node;
	list->prev=node;
}

void AddTail(struct List *list,struct Node *node) {
	node->next=list->next;
	node->prev=(struct Node *)&list->next;
	node->next->prev=node;
	list->next=node;
}

struct Node *RemHead(struct List *list) {
	struct Node *node;

	node=list->prev;
	if (!node->prev) return node;

	list->prev=node->prev;
	list->prev->next=(struct Node *)&list->prevnext;
	return node;
}

struct Node *RemTail(struct List *list) {
	struct Node *node;

	node=list->next;
	if (!node->next) return node;

	list->next=node->next;
	list->next->prev=(struct Node *)&list->next;
	return node;
}

void Remove(struct Node *node) {
	node->next->prev=node->prev;
	node->prev->next=node->next;
}

ulong ListLength(struct List *list) {
	struct Node *node,*next;
	ulong siz=0;

	node=list->prev;

	while(next=node->prev) {
		++siz;
		node=next;
	};

	return siz;
}

struct Node **MakeNodeTable(struct List *list) {
	struct Node *node,**table,**temp;
	ulong siz=ListLength(list);

	if (!(table=(struct Node **)malloc(sizeof(struct Node *)*(siz+1))))
		return NULL;

	node=list->prev;

	*table=(struct Node *)siz;

	temp=table+1;

	while (siz--) {
		*temp++=node;
		node=node->prev;
	};

	return table+1;
}

void DisposeNodeTable(struct Node **table) {
	free(table-1);
}

void DisposeNodeTableCompletely(struct Node **table) {
	ulong siz=(ulong)table[-1];
	struct Node **temp=table;

	while (siz--) free(*temp++);

	DisposeNodeTable(table);
}

void DisposeNodesInList(struct List *list) {
	struct Node *n=list->prev;
	struct Node *next;

	while(next=n->prev) {
		free(n);
		n=next;
	};
}

