#ifndef	VGAPAINT_VIDEO_H
#define	VGAPAINT_VIDEO_H

#include <a/types.h>
#include <a/mem.h>

#ifdef	VGAPAINT_VIDEO
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

#define	VPORT_ATTR	(0x3c0)
#define	VPORT_ATTREAD	(0x3c1)
#define	VPORT_SEQA	(0x3c4)
#define	VPORT_SEQD	(0x3c5)
#define	VPORT_GRAPHA	(0x3ce)
#define	VPORT_GRAPHD	(0x3cf)
#define	VPORT_CRTCA	(0x3d4)
#define	VPORT_CRTCD	(0x3d5)

void	vid_set_attr(char reg,char val);
void	vid_set_seq(char reg,char val);
void	vid_set_graph(char reg,char val);
void	vid_set_crtc(char reg,char val);
char	vid_get_attr(char reg);

#define	vid_set_attr(reg,val)	outportb(VPORT_ATTR,reg),outportb(VPORT_ATTR,val),outportb(VPORT_ATTR,0x32)
#define	vid_set_seq(reg,val)	outportb(VPORT_SEQA,reg),outportb(VPORT_SEQD,val)
#define	vid_set_graph(reg,val)	outportb(VPORT_GRAPHA,reg),outportb(VPORT_GRAPHD,val)
#define	vid_set_crtc(reg,val)	outportb(VPORT_CRTCA,reg),outportb(VPORT_CRTCD,reg)

#pragma aux vid_get_attr=	\
	"mov dx,03c0h",		\
	"out dx,al",		\
	"inc dx",		\
	"in  al,dx",		\
	"mov ah,al",		\
	"dec dx",		\
	"mov al,20h",		\
	"out dx,al",		\
	"mov al,ah",		\
	parm [al] value [al] modify exact nomemory [ax dx];

extern uchar font6[];

typedef	long		coord;

///////////////////// DISPLAY METRICS ///////////////////

EXTERN	coord	x_aspect INIT(1);
EXTERN	coord	y_aspect INIT(1);
EXTERN	ulong	x_ratio INIT(0x10000);
EXTERN	ulong	y_ratio	INIT(0x10000);

#define	XPOINT	(x_aspect)
#define	YPOINT	(y_aspect)

/////////////////////////////////////////////////////////

struct RectBound {
	coord x1,y1,x2,y2;
};

struct BitMap {
	uchar *vm;
	uchar *zvm;		/* backup for Mode 'Z' routines */
	long x1,y1,x2,y2,width,height;
	long bpr;		/* mode 13 bytes per row */
	long zbpr;		/* mode Z bytes per row */
	coord syncx1,syncy1,syncx2,syncy2;
	coord xbias,ybias;
	ulong size;
	boolean	syncrect;
	boolean	accelerate;	// does not have to be enabled but allows Accelerated drivers to work faster
	uchar	pad[2];
	uchar	*pal;
	long	xdpi,ydpi;
};

typedef	struct BitMap	*BMP;
typedef	long	color;

struct Block {
	struct BitMap bm;
	long x,y;
	long xs,ys;
};

typedef struct Block *BLOCK;

enum	VD_InitCode	 {
	VD_BADCODE=0,		// used in toolicon.h
	VD_STARTUP=1,		/* driver initialization */
	VD_REINIT,		/* driver re-initialization (like, after shelling out) */
	VD_TO13,		/* jump to mode 13h (at least to a normal VGA mode) */
	VD_FROM13,		/* reset VGA to driver-specific settings */
	VD_CLOSEDOWN,		/* release all memory, reset VGA, and cleanup */
	VD_GODIRECT,		/* turn on direct-to-memory mode if available */
	VD_GOBUFFER,		/* enable buffering mode if available */
	VD_RESIZE,		/* resize screen */
	VD_SETSIZE,		/* set initial size */
	VD_INITMAXSIZE,		// initialize (to get max size - for inst, VideoX)
	VD_SETLINECOMPARE,	// set the Line Compare (splitscreen)
				// x=0	turn off line compare
				// x=n  turn on line compare
				//	return 1: failed
				//	return 0: success
	VD_GETLINECOMPARE,	// get Line Compare position
	VD_SETSTART,		// set start display position
	VD_GETSTART,		// get start display position
};

struct	VDev	{	/* video device (set of drawing routines) */
	void	(*set)(BMP,int);
	void	(*plot)(BMP,long,long,color);
	color	(*point)(BMP,long,long);
	void	(*bar)(BMP,long,long,long,long,color);
	void	(*bitblt)(BMP,long,long,BMP,long,long,long,long);
	void	(*bitbltcolor)(BMP,long,long,BMP,long,long,long,long,uchar,uchar);
	void	(*bitblttrans)(BMP,long,long,BMP,long,long,long,long,uchar);
	void	(*bitbltswap)(BMP,long,long,BMP,long,long,long,long);
	void	(*bitbltswaptrans)(BMP,long,long,BMP,long,long,long,long,uchar);
	void	(*bitbltswapmask)(BMP,long,long,BMP,uchar *,long,long,long,long,uchar);
	void	(*bltpattern)(BMP,ushort *,long,long,long,long,color,color);
	void	(*bltpattern3d)(BMP,ulong *,long,long,long,long);
	void	(*text6)(BMP,long,long,char *,color,color);
	void	(*text6t)(BMP,long,long,char *,color);
	void	(*text6lim)(BMP,long,long,char *,color,color,long);
	void	(*hline)(BMP,long,long,long,color);
	void	(*vline)(BMP,long,long,long,color);
	void	(*line)(BMP,long,long,long,long,color);
	void	(*box)(BMP,long,long,long,long,color);
	void	(*circle)(BMP,long,long,long,color);
	void	(*ellipse)(BMP,long,long,long,long,color);
	BLOCK	(*blocksave)(BMP,long,long,long,long);
	void	(*blockrestore)(BMP,BLOCK);
	void	(*hblit)(BMP,long,long,long,long,long);
	void	(*vblit)(BMP,long,long,long,long,long);
	void	(*tile)(BMP,BMP,coord,coord,coord,coord,coord,coord);
	ulong	(*rassize)(coord,coord);
	ulong	(*bpr)(coord);
	boolean	(*init)(enum VD_InitCode,long x,long y);
	void	(*refresh)(void);
	void	(*rhline)(coord x,coord y,uchar *mem,coord xs);
	void	(*quickfill)(BMP,coord,coord,coord,coord);
	void	(*rbitblt)(coord x1,coord y1,coord xs,coord ys,uchar *mem,long dmod,boolean no_offset);
	void	(*drawptr)(struct MousePointerInfo *,coord x,coord y);
	void	(*eraseptr)(struct MousePointerInfo *);
	void	(*rhlineread)(coord x,coord y,uchar *mem,coord xs);
	void	(*hideptr)(struct MousePointerInfo *,boolean);
	void	(*changeptr)(struct MousePointerInfo *);
	void	(*bitbltxor)(BMP,long,long,BMP,long,long,long,long);
};

struct VDevSpecs {
	coord	minx,miny;
	coord	maxx,maxy;
	coord	o_vidx,o_vidy;
	coord	o_maxx,o_maxy;
};

EXTERN struct VDev	*vd;
EXTERN struct VDevSpecs	*vds;
EXTERN struct BitMap realvidbm;

void	WaitVBLOn(void);
void	WaitVBLOff(void);
void	WaitVBL(void);
#pragma	aux WaitVBLOn=			\
		"mov	dx,3DAh",	\
		"l:",			\
		"in	al,dx",		\
		"and	al,8",		\
		"jz	l"		\
		modify exact [dx al];

#pragma	aux WaitVBLOff="mov	dx,3DAh",	\
		"l:",			\
		"in	al,dx",		\
		"and	al,8",		\
		"jnz	l"		\
		modify exact [dx al];

#pragma	aux WaitVBL="mov	dx,3DAh",	\
		"l:",			\
		"in	al,dx",		\
		"and	al,8",		\
		"jnz	l",		\
		"l2:",			\
		"in	al,dx",		\
		"and	al,8",		\
		"jz	l2",		\
		modify exact [dx al];

void rectcopy(uchar *dst,ulong dsiz,uchar *src,ulong ssiz,ulong xs,ulong ys);
#pragma aux rectcopy =			\
	"and ecx,ecx",			\
	"jz xit",			\
	"and edx,edx",			\
	"jz xit",			\
	"sub eax,ecx",			\
	"sub ebx,ecx",			\
	"push ebp",			\
	"mov ebp,ecx",			\
	"l:",				\
	"mov ecx,ebp",			\
	"shr ecx,2",			\
	"rep movsd",			\
	"mov ecx,ebp",			\
	"and ecx,3",			\
	"rep movsb",			\
	"add esi,eax",			\
	"add edi,ebx",			\
	"dec edx",			\
	"jnz l",			\
	"pop ebp"			\ 
	"xit:",				\
	modify exact [eax ebx ecx edx esi edi]	\
	parm [edi] [ebx] [esi] [eax] [ecx] [edx];

void *asm_flipx(void *src,ulong bytecnt);
#pragma aux asm_flipx=			\
	"lea edi,[esi+ecx-1]",		\
	"shr ecx,1",			\
	"jz xit",			\
	"l:",				\
	"mov al,[edi]",			\
	"xchg [esi],al",		\
	"mov [edi],al",			\
	"inc esi",			\
	"dec edi",			\
	"dec ecx",			\
	"jne l",			\
	"xit:"				\
	modify exact [al ecx esi edi]	\
	parm [esi] [ecx]		\
	value [esi];

#define	vid_fastinside(b,x,y) ((x)>=(b)->x1 && (x)<(b)->x2 && (y)>=(b)->y1 && (y)<(b)->y2)

void	vid_setmode(int mode);
void	vid_cursmove(long x,long y);
void	vid_initBitMap(struct BitMap *bm,uchar *vm,long x,long y,long xs,
		long ys,long bpr,uchar *palette);
void	vid_cloneBitMap(struct BitMap *bm,struct BitMap *old,long x,long y,long xo,long yo,long xs,long ys);
void	vid13_set(struct BitMap *bm,color c);
void	vid13_plot(struct BitMap *bm,long x,long y,color c);
color	vid13_point(struct BitMap *bm,long x,long y);
boolean	vid_rectclip(struct BitMap *dst,long *x1,long *y1,long *xs,long *ys);
boolean	vid_rectclip2(struct BitMap *src,long *x1,long *y1,struct BitMap *dst,
		long *x2,long *y2,long *xs,long *ys);
void	vid13_bar(struct BitMap *dst,long x1,long y1,long xs,long ys,
		color c);
void	vid13_bitblt(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys);
void	vid13_bitbltxor(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys);
void	vid13_bitbltcolor(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys,uchar c,uchar c2);
void	vid13_bitblttrans(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys,uchar c);
void	vid13_bitbltswap(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys);
void	vid13_bitbltswaptrans(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		long x2,long y2,long xs,long ys,uchar c);
void	vid13_bitbltswapmask(struct BitMap *src,long x1,long y1,struct BitMap *dst,
		uchar *mask,long x2,long y2,long xs,long ys,uchar c);
void	vid13_bltpattern(struct BitMap *dst,ushort *data,long x1,long y1,long xs,long ys,color fore,color back);
void	vid13_bltpattern3d(struct BitMap *dst,ulong *data,long x1,long y1,long xs,long ys);
void	vid13_bltpattern3dscale(struct BitMap *dst,ulong *data,long x1,long y1,long xs,long ys,long xmult,long ymult);
void	vid13_text6lim(struct BitMap *dst,long x,long y,char *s,color fore,color back,long lim);
void	vid13_text6trans(struct BitMap *dst,long x,long y,char *s,color c);
void	vid13_hline(struct BitMap *dst,long x1,long x2,long y,color c);
void	vid13_vline(struct BitMap *dst,long x,long y1,long y2,color c);
void	vid13_quickfill(BMP dst,coord x1,coord y1,coord x2,coord y2);
void	vid13_flipx(struct BitMap *dst,coord x1,coord y1,coord xs,coord ys);
void	vid13_flipy(struct BitMap *dst,coord x1,coord y1,coord xs,coord ys);
void	vid13_rotateright(BMP src,coord x1,coord y1,BMP dst,coord x2,coord y2,coord xs,coord ys);
void	vid13_scale(BMP src,long x1,long y1,long xs1,long ys1,BMP dst,long x2,long y2,long xs2,long ys2);
void	vid13_rotate(BMP src,long x1,long y1,long xs,long ys,long xc,long yc,BMP dst,long xc2,long yc2,double angle);
void	vid_rotate_size(long xs,long ys,long xc,long yc,long *xrs,long *yrs,long *xrc,long *yrc,double angle);
void	vid_rotate_coordinate(long *px,long *py,double angle);
void	vid13_tile(BMP src,BMP dst,coord x,coord y,coord xs2,coord ys2,coord xo,coord yo);
ulong	vid13_rassize(coord xs,coord ys);
ulong	vid13_bpr(coord xs);
void	vid13_translate(BMP dst,coord x1,coord y1,coord xs,coord ys,uchar *trnbuf);
boolean	vid13_init(enum VD_InitCode vdic,long x,long y);
void	vid13_rhline(coord x,coord y,uchar *mem,coord width);
void	vid13_rhlineread(coord x,coord y,uchar *mem,coord width);
void	vid13_rbitblt(coord x1,coord y1,coord xs,coord ys,uchar *mem,long dmod,boolean no_offset);
void	vid13_drawptr(struct MousePointerInfo *mpi,coord x,coord y);
void	vid13_eraseptr(struct MousePointerInfo *mpi);
void	vid13_hideptr(struct MousePointerInfo *mpi,boolean state);
void	vid13_changeptr(struct MousePointerInfo *mpi);
void	vid13_line(BMP bm,coord x1,coord y1,coord x2,coord y2,color c);
void	vid13_htrapezoid(BMP dst,coord x1,coord x2,coord y1,coord x3,coord x4,coord y2,color c);

void	vid_tap_point(BMP dst,coord x,coord y);
void	vid_tap_rect(BMP dst,coord x1,coord y1,coord xs,coord ys);
void	vid_tap_rect2(BMP dst,coord x1,coord y1,coord x2,coord y2);
void	vid_tap_bitmap(BMP dst,BMP src);
void	vid_tap_reset(BMP dst);

void	vid_refresh(void);
boolean	vid_line_clip(BMP dst,coord *x1,coord *y1,coord *x2,coord *y2);
void	vid_line(struct BitMap *dst,long x1,long y1,long x2,long y2,color c,void (*)(BMP,coord,coord,color),boolean nofirstdot);
void	vid_box(struct BitMap *dst,long x1,long y1,long x2,long y2,color c);
void	vid_circle(struct BitMap *dst,long x1,long y1,long r,color c);
void	vid_circle_func(BMP dst,long x,long y,long iy,color c,void (*plot)(BMP,coord,coord,color));
void	vid_ellipse(struct BitMap *dst,long x1,long y1,long rx,long ry,color c);
void	vid_ellipse_func(BMP dst,long xc,long yc,long a,long b,long c,void (*plot)(BMP,coord,coord,color));
BLOCK	vid_blocksave(BMP bm,long x1,long y1,long xs,long ys);
void	vid_blockrestore(BMP bm,BLOCK bl);

void	vid_printf6(BMP bm,long x,long y,color fore,color back,char *format, ...);
void	vid_text6(BMP bm,long x,long y,char *str,color fore,color back);
void	vid_hblit(BMP bm,long x1,long y1,long xs,long ys,long dx);
void	vid_vblit(BMP bm,long x1,long y1,long xs,long ys,long dy);

void	vid_draw3d(BMP bm,long x1,long y1,long x2,long y2);
void	vid_inv3d(BMP bm,long x1,long y1,long x2,long y2);

void	vid_setRGB6(uchar c,uchar r,uchar g,uchar b);
void	vid_getRGB6(uchar c,uchar *r,uchar *g,uchar *b);
void	vid_loadRGB6(uchar c,uchar *m,long n);
void	vid_saveRGB6(uchar c,uchar *m,long n);
void	vid_setpreg(uchar pr,uchar col);
void	vid_flash(long time);
void	vid_polyline(BMP bm,color c,long lcnt, ...);

color vid_ctran(color cp);

void	Message(char *f, ...);

void	vid_make_remap(uchar *src,uchar *dst,uchar *map,long src_colors,long dst_colors);

EXTERN struct VDev vd13
#ifdef	VGAPAINT_VIDEO
	={
		&vid13_set,
		&vid13_plot,
		&vid13_point,
		&vid13_bar,
		&vid13_bitblt,
		&vid13_bitbltcolor,
		&vid13_bitblttrans,
		&vid13_bitbltswap,
		&vid13_bitbltswaptrans,
		&vid13_bitbltswapmask,
		&vid13_bltpattern,
		&vid13_bltpattern3d,
		&vid_text6,		/* rely on limit text routine */
		&vid13_text6trans,
		&vid13_text6lim,
		&vid13_hline,
		&vid13_vline,
		&vid13_line,
		&vid_box,
		&vid_circle,
		&vid_ellipse,
		&vid_blocksave,
		&vid_blockrestore,
		&vid_hblit,
		&vid_vblit,
		&vid13_tile,
		&vid13_rassize,
		&vid13_bpr,
		&vid13_init,
		&vid_refresh,
		&vid13_rhline,
		&vid13_quickfill,
		&vid13_rbitblt,
		&vid13_drawptr,
		&vid13_eraseptr,
		&vid13_rhlineread,
		&vid13_hideptr,
		&vid13_changeptr,
		&vid13_bitbltxor
	}
#endif
;

EXTERN struct VDev vd_std
#ifdef	VGAPAINT_VIDEO
	={
		&vid13_set,
		&vid13_plot,
		&vid13_point,
		&vid13_bar,
		&vid13_bitblt,
		&vid13_bitbltcolor,
		&vid13_bitblttrans,
		&vid13_bitbltswap,
		&vid13_bitbltswaptrans,
		&vid13_bitbltswapmask,
		&vid13_bltpattern,
		&vid13_bltpattern3d,
		&vid_text6,		/* rely on limit text routine */
		&vid13_text6trans,
		&vid13_text6lim,
		&vid13_hline,
		&vid13_vline,
		&vid13_line,
		&vid_box,
		&vid_circle,
		&vid_ellipse,
		&vid_blocksave,
		&vid_blockrestore,
		&vid_hblit,
		&vid_vblit,
		&vid13_tile,
		&vid13_rassize,
		&vid13_bpr,
		&vid13_init,
		&vid_refresh,
		&vid13_rhline,
		&vid13_quickfill,
		&vid13_rbitblt,
		&vid13_drawptr,
		&vid13_eraseptr,
		&vid13_rhlineread,
		&vid13_hideptr,
		NULL
	}
#endif
;

EXTERN struct VDevSpecs	vd13specs
#ifdef	VGAPAINT_VIDEO
={
	320,200,320,200,320,200,320,200
}
#endif
;

#undef	EXTERN
#undef	INIT

#endif

